<?php

namespace STM\Prediction;

use \Exception;
use STM\StmFactory;

/**
 * Test class for PredictionValidator.
 * Generated by PHPUnit on 2011-12-03 at 15:47:46.
 * @group prediction
 */
class PredictionValidatorTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $predictions;

    protected function setUp() {
        $this->bad_values = array('', null, false, array(), new Exception());

        $this->predictions = array();
        foreach (StmFactory::find()->User->findAll() as $user) {
            $this->predictions[] = StmFactory::find()->Prediction->findByUser($user);
        }
    }

    public function testCheck_create() {
        foreach ($this->bad_values as $value) {
            PredictionValidator::init();
            $this->assertFalse(PredictionValidator::checkCreate($value));
            PredictionValidator::init();
            $this->assertFalse(PredictionValidator::checkCreate(array($value)));

            // match must be instance of Match and user instance of user
            PredictionValidator::init();
            $this->assertFalse(PredictionValidator::checkCreate(array('match' => $value, 'user' => $value, 'score_home' => 5, 'score_away' => 6)));
            PredictionValidator::init();
            $this->assertFalse(PredictionValidator::checkCreate(array('match' => $value, 'user' => StmFactory::find()->User->findById(1), 'score_home' => 5, 'score_away' => 6)));                          
        }
        foreach ($this->predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                // cannot create new prediction if already exist
                $match = StmFactory::find()->Match->findById ($prediction->getIdMatch());
                $user = StmFactory::find()->User->findById($prediction->getIdUser());
                PredictionValidator::init();
                $this->assertFalse(PredictionValidator::checkCreate(array('match' => $match, 'user' => $user, 'score_home' => 5, 'score_away' => 6)));                          
            }
        }
    }

    public function testCheck_updateScore() {
        // not set user -> fail
        PredictionValidator::init();
        $this->assertFalse(PredictionValidator::checkUpdateScore(array('score_home' => 56, 'score_away' => '44')));

        foreach ($this->predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                PredictionValidator::setPrediction($prediction);
                foreach ($this->bad_values as $value) {
                    // argument must be array('score_home' => ...., 'score_away' => ...)
                    PredictionValidator::init();
                    $this->assertFalse(PredictionValidator::checkUpdateScore($value));

                    // scores must be int 
                    PredictionValidator::init();
                    $this->assertFalse(PredictionValidator::checkUpdateScore(array('score_home' => $value, 'score_away' => $value)));

                    // score <0,25 500>
                    PredictionValidator::init();
                    $this->assertFalse(PredictionValidator::checkUpdateScore(array('score_home' => -1, 'score_away' => 25505)));
                }

                // at least change in one score (home or away
                PredictionValidator::init();
                $this->assertFalse(PredictionValidator::checkUpdateScore(array('score_home' => $prediction->getScoreHome(), 'score_away' => $prediction->getScoreAway())));
                PredictionValidator::resetPrediction();
            }
        }
    }

}

?>
